Subject: Re: 1.75

From: Zheng Gengbin <[email-masked]>
Date: Thu, 27 Mar 1997 11:09:18 +0800 (EAT)

I cannot believe your current version can work on the testsuite 
samples correctly , there are some obvious errors there 

I will give you error report on my machine :

adi.f :
Program received signal SIGSEGV, Segmentation fault.
SgExpression::operand (this=0x0, i=2) at fromsage++.C:1385
1385          ll =  NODE_OPERAND1(thellnd);
(gdb) bt
#0  SgExpression::operand (this=0x0, i=2) at fromsage++.C:1385
#1  0x804dd51 in deal_Distribute_array (s=0x80bee58, expr1=0x80bed38, 
    expr2=0x80bed30) at distarray.C:148
#2  0x804de3a in analyse_distribute (s=0x80bee58) at distarray.C:163
#3  0x804a02d in analyse (s=0x80bee58) at hf.C:644
#4  0x8049e94 in analyse (s=0x80bee88) at hf.C:593
#5  0x8049dd4 in analyse (s=0x80bee98) at hf.C:572
#6  0x804af41 in main (argc=2, argv=0xbffff350) at hf.C:1086
#7  0x8048c7b in _start ()

forall4.f:

Program received signal SIGFPE, Arithmetic exception.
0x8054983 in devide (s1=215, s2=0) at detect_comm.C:135
135             int q = s1 % s2;
(gdb) bt
#0  0x8054983 in devide (s1=215, s2=0) at detect_comm.C:135
#1  0x80546fd in pcrc_detect_communication (dad_x=0xbffff274, 
    dad_y=0xbffff25c, l=0xbffff258, u=0xbffff254, stride=0xbffff250, 
    a0=0xbffff24c, b0=0xbffff248, a1=0xbffff244, b1=0xbffff240, 
    amount=0xbffff23c) at detect_comm.C:31
#2  0x804b9dc in detect_communication (s=0x80b8d80, counter=1)
    at reference.C:286
#3  0x804bc5b in detect_forall_reference (s=0x80b8d80) at reference.C:412
#4  0x8049c05 in analyse (s=0x80b8d80) at hf.C:743
#5  0x8049919 in analyse (s=0x80b8e38) at hf.C:593
#6  0x80498a9 in analyse (s=0x80b8e48) at hf.C:572
#7  0x804a3af in main (argc=2, argv=0xbffff360) at hf.C:1086
#8  0x8048c7b in _start ()

Also diff the result of the forall3.f and forall4.f between the version 
of mine 1.75 and your record , I think the difference just reflect the bugs
in old version :

>diff forall3_node.f forall3_node.f.rec | more

13,14c13,14
<       real :: Y(0:2292149)
<       real :: X(0:2292149)
---
>       real :: Y(0:9162050)
>       real :: X(0:9162050)
26,27c26
<       call pcrc_set_array_align (pcrc_dad_Y,1,0,1088,2,(-8),pcrc_rng_T(1&
<      &))
---
>       call pcrc_set_array_align (pcrc_dad_Y,1,0,1088,2,8,pcrc_rng_T(1))
32,33c31
<       call pcrc_set_array_align (pcrc_dad_X,1,0,1088,2,(-6),pcrc_rng_T(1&
<      &))
---
>       call pcrc_set_array_align (pcrc_dad_X,1,0,1088,2,6,pcrc_rng_T(1))
210c208
<       call pcrc_set_array_align (pcrc_dad_Y,1,5,348,1,0,pcrc_rng_T(1))
---
>       call pcrc_set_array_align (pcrc_dad_Y,1,5,348,0,0,pcrc_rng_T(1))

Line 26,27c26 , the offset is -8 not 8 ,
Line 32,33c31 , same as above.
Line 210c208  , the stride should be 1 not 0 ,
please check the source file and make your decision .

Zheng